Imports System.Drawing
Imports System.Windows.Forms
Imports System.Data
Imports System.Data.OleDb
Imports System.Collections
Imports System.ComponentModel

Public Class AccessExplorer
    Inherits System.WinDows.Forms.Form
    Private userName As String
    Private password As String
    Private database As String
    Private SQLServer As String
    Private m_sConnectString As String
    Private myTableData As DataSet = New DataSet()
    Private myViewsData As DataSet = New DataSet()
    Private myStoredProcData As DataSet = New DataSet()
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByRef userName As String, ByRef password As String, ByRef database As String, ByRef sqlServer As String)
        MyBase.New()
        AccessExplorer = Me
        'ME call is required by the Win Form Designer.
        InitializeComponent()

        Me.userName = userName
        Me.password = password
        Me.database = database
        Me.SQLServer = sqlServer
        AddHandler Closing, AddressOf AccessExplorer_OnClosing
        'TODO: Add any initialization after the InitializeComponent() call
    End Sub

    'Form overrides dispose to clean up the component list.
    Public Overloads Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub

#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents contextMenu1 As ContextMenu
    Private WithEvents listView1 As ListView
    Private WithEvents treeView1 As TreeView

    Dim WithEvents AccessExplorer As System.Windows.Forms.Form

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.contextMenu1 = New ContextMenu()
        Me.treeView1 = New TreeView()
        Me.listView1 = New ListView()

        '@design Me.TrayHeight = 90
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        '@design contextMenu1.SetLocation(New System.Drawing.Point(7, 7))

        treeView1.Location = New System.Drawing.Point(0, 8)
        treeView1.Size = New System.Drawing.Size(216, 268)
        treeView1.TabIndex = 0
        treeView1.Anchor = AnchorStyles.Top.Bottom.Left
        treeView1.Visible = True

        listView1.Location = New System.Drawing.Point(216, 8)
        listView1.Size = New System.Drawing.Size(636, 268)
        listView1.ForeColor = System.Drawing.SystemColors.WindowText
        listView1.TabIndex = 1
        listView1.Anchor = AnchorStyles.Bottom.Left.Top.Right
        listView1.Visible = True
        Me.Text = "AccessExplorer"
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(560, 277)

        Me.Controls.Add(listView1)
        Me.Controls.Add(treeView1)
    End Sub

#End Region
    Protected Sub AccessExplorer_OnClosing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        Me.WindowState = FormWindowState.Maximized
        e.Cancel = True
    End Sub
    Protected Sub treeView1_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
        Select Case e.Button
            Case MouseButtons.Left

            Case MouseButtons.Right
                Dim mySelectedNode As TreeNode = Nothing
                mySelectedNode = treeView1.GetNodeAt(e.X, e.Y)
                treeView1.SelectedNode = mySelectedNode
                If Not (mySelectedNode Is Nothing) Then
                    Dim myParentNode As TreeNode = mySelectedNode.Parent
                    If Not (myParentNode Is Nothing) Then
                        If (myParentNode.Text.ToString() = "Tables") Then
                            ShowContextMenuForTable()
                            treeView1.ContextMenu = contextMenu1
                        ElseIf (myParentNode.Text.ToString() = "Stored Procs") Then
                            treeView1.ContextMenu = contextMenu1
                        ElseIf (myParentNode.Text.ToString() = "Views") Then
                            ShowContextMenuForTable()
                            treeView1.ContextMenu = contextMenu1
                        Else
                            treeView1.ContextMenu = Nothing
                            listView1.Clear()
                        End If
                    Else
                        treeView1.ContextMenu = Nothing
                    End If
                    'Check the Parent if it is Tables then Show then ME menus
                End If
            Case MouseButtons.Middle

            Case MouseButtons.None

            Case Else
        End Select

    End Sub
    Private Sub ShowContextMenuForTable()
        contextMenu1.MenuItems.Clear()
        contextMenu1.MenuItems.Add("Details", New System.EventHandler(AddressOf Me.OnPopupDetail))
        'contextMenu1.MenuItems.Add("References", New System.EventHandler(AddressOf Me.OnPopupReferences))
    End Sub
    Protected Sub OnPopupDetail(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                listView1.Clear()
                listView1.View = View.Details
                Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                myColumnHeader.Text = "ColumnName"
                listView1.Columns.Add(myColumnHeader)
                myColumnHeader = New ColumnHeader()
                myColumnHeader.Text = "AutoIncrement"
                listView1.Columns.Add(myColumnHeader)
                myColumnHeader = New ColumnHeader()
                myColumnHeader.Text = "DataType"
                listView1.Columns.Add(myColumnHeader)
                myColumnHeader = New ColumnHeader()
                myColumnHeader.Text = "AllowNull"
                listView1.Columns.Add(myColumnHeader)
                myColumnHeader = New ColumnHeader()
                myColumnHeader.Text = "Unique"
                listView1.Columns.Add(myColumnHeader)
                Dim myValues(5) As String
                Dim myColumn As DataColumn
                For Each myColumn In myTable.Columns
                    myValues(0) = myColumn.ColumnName
                    myValues(1) = myColumn.AutoIncrement.ToString()
                    myValues(2) = myColumn.DataType.FullName.ToString()
                    myValues(3) = myColumn.AllowDBNull.ToString()
                    myValues(4) = myColumn.Unique.ToString()
                    Dim myListItem As ListViewItem = New ListViewItem(myValues)
                    listView1.Items.Add(myListItem)
                Next
            End If
        Next
    End Sub
    Public ReadOnly Property ConnectionString() As String
        Get
            Return m_sConnectString
        End Get
    End Property
    Public Function buildTreeView() As Boolean
        Dim connectedFlag As Boolean = False
        Dim database As CAccessDatabase = New CAccessDatabase()
        Dim connString As String = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                   "Data Source=" & Me.database & ";" & _
                   "Jet OLEDB:System database=" & SQLServer & ";User ID =" & userName & ";Password =" & password & ";"
        m_sConnectString = connString
        database.connectString = connString
        connectedFlag = database.Connect()



        If (connectedFlag) Then
            Dim myRootNode As TreeNode = New TreeNode(Me.database)
            Dim successFlag As Boolean = False
            successFlag = database.myDatabaseTables(myTableData)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                Dim myTable As DataTable
                For Each myTable In myTableData.Tables
                    'ME is the Main Table
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = myTable.TableName.ToString()
                    myArrayList.Add(myTableName)
                Next
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Tables", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            Dim myDataReader As OleDbDataReader

            successFlag = database.GetQueries(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Queries", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            successFlag = database.GetForms(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Forms", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            successFlag = database.GetReports(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Reports", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            successFlag = database.GetMacros(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Macros", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            successFlag = database.GetModules(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Modules", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            treeView1.Nodes.Add(myRootNode)
        Else
            MessageBox.Show(Me, "Error in the connection Parameters, retry.")
        End If
        Return connectedFlag
    End Function
End Class
