Imports System.Drawing
Imports System.Windows.Forms
Imports System.Data
Imports System.Data.OleDb
Imports System.Collections
Imports System.ComponentModel


Public Class frmDatabaseExplorer
    Inherits System.Windows.Forms.Form
    Private userName As String
    Private password As String
    Private database As String
    Private SQLServer As String
    Private m_sConnectString As String
    Private myTableData As DataSet = New DataSet()
    Private myViewsData As DataSet = New DataSet()
    Private myStoredProcData As DataSet = New DataSet()
    Public Sub New(ByVal userName As String, ByVal password As String, ByVal database As String, ByVal SQLServer As String)
        MyBase.New()
        
        DatabaseExplorer = Me
        
        'ME call is required by the Win Form Designer.
        InitializeComponent()
        Me.userName = userName
        Me.password = password
        Me.database = database
        Me.SQLServer = sqlServer
        AddHandler Closing, AddressOf DatabaseExplorer_OnClosing
        'TODO: Add any initialization after the InitializeComponent() call
    End Sub
    
    'Form overrides dispose to clean up the component list.
    Public Overloads Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub
    Protected Sub DatabaseExplorer_OnClosing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        Me.WindowState = FormWindowState.Maximized
        e.Cancel = True
    End Sub
    Protected Sub treeView1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Select Case e.Button
            Case MouseButtons.Left

            Case MouseButtons.Right
                Dim mySelectedNode As TreeNode = Nothing
                mySelectedNode = treeView1.GetNodeAt(e.X, e.Y)
                treeView1.SelectedNode = mySelectedNode
                If Not (mySelectedNode Is Nothing) Then
                    Dim myParentNode As TreeNode = mySelectedNode.Parent
                    If Not (myParentNode Is Nothing) Then
                        If (myParentNode.Text.ToString() = "Tables") Then
                            ShowContextMenuForTable()
                            treeView1.ContextMenu = contextMenu1
                        ElseIf (myParentNode.Text.ToString() = "Stored Procs") Then
                            ShowContextMenuForStoredProcedure()
                            treeView1.ContextMenu = contextMenu1
                        ElseIf (myParentNode.Text.ToString() = "Views") Then
                            ShowContextMenuForTable()
                            treeView1.ContextMenu = contextMenu1
                        Else
                            treeView1.ContextMenu = Nothing
                            listView1.Clear()
                        End If
                    Else
                        treeView1.ContextMenu = Nothing
                        listView1.Clear()
                    End If
                    'Check the Parent if it is Tables then Show then ME menus
                End If
            Case MouseButtons.Middle

            Case MouseButtons.None

            Case Else
        End Select

    End Sub
    Private Sub ShowContextMenuForTable()
        contextMenu1.MenuItems.Clear()
        contextMenu1.MenuItems.Add("Details", New System.EventHandler(AddressOf Me.OnPopupDetail))
        contextMenu1.MenuItems.Add("Identity", New System.EventHandler(AddressOf Me.OnPopupIdentity))
        contextMenu1.MenuItems.Add("FileGroups", New System.EventHandler(AddressOf Me.OnPopupFileGroups))
        contextMenu1.MenuItems.Add("Constraints", New System.EventHandler(AddressOf Me.OnPopupConstraints))
        contextMenu1.MenuItems.Add("References", New System.EventHandler(AddressOf Me.OnPopupReferences))
        contextMenu1.MenuItems.Add("Indexes", New System.EventHandler(AddressOf Me.OnPopupIndexes))
        contextMenu1.MenuItems.Add("RowGUIDcols", New System.EventHandler(AddressOf Me.OnPopupGUID))
    End Sub
    Protected Sub OnPopupDetail(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                If (myTable.Columns(0).ToString() = "Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupIdentity(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                If (myTable.Columns(0).ToString() = "Identity") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupFileGroups(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                If (myTable.Columns(0).ToString() = "Data_located_on_filegroup") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next

                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupConstraints(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                If (myTable.Columns(0).ToString() = "constraint_type") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupReferences(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                If (myTable.Columns(0).ToString() = "Table is referenced by foreign key") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub

    Protected Sub OnPopupGUID(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                If (myTable.Columns(0).ToString() = "RowGuidCol") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub

    Protected Sub OnPopupIndexes(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                If (myTable.Columns(0).ToString() = "index_name") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub
    Private Sub ShowContextMenuForStoredProcedure()
        contextMenu1.MenuItems.Clear()
        contextMenu1.MenuItems.Add("Parameters", New System.EventHandler(AddressOf Me.OnPopupParameters))
    End Sub

    Public ReadOnly Property ConnectionString() As String
        Get
            Return m_sConnectString
        End Get
    End Property
    Public Function buildTreeView() As Boolean
        Dim connectedFlag As Boolean = False
        Dim database As CDatabase = New CDatabase()
        Dim connString As String = "Provider=SQLOLEDB.1;Persist Security Info = False;" & _
   "Initial Catalog = " & Me.database & ";Data Source = " & SQLServer & ";User ID =" & userName & ";Password =" & password & ";"
        m_sConnectString = connString
        database.connectString = connString
        connectedFlag = database.Connect()
        If (connectedFlag) Then
            Dim myRootNode As TreeNode = New TreeNode(Me.database)
            Dim successFlag As Boolean = False
            successFlag = database.myDatabaseTables(myTableData)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                Dim myTable As DataTable
                For Each myTable In myTableData.Tables
                    'Me is the Main Table
                    If (myTable.Columns(0).ToString() = "Name") Then
                        Dim myTableName As TreeNode = New TreeNode()
                        myTableName.Text = myTable.TableName.ToString()
                        myArrayList.Add(myTableName)
                    End If
                Next
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)

                Dim myTableNameNode As TreeNode = New TreeNode("Tables", myTables)
                myRootNode.Nodes.Add(myTableNameNode)

            End If
            Dim myDataReader As OleDbDataReader

            successFlag = database.myDatabaseView(myViewsData)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                Dim myTable As DataTable
                For Each myTable In myViewsData.Tables
                    'Me is the Main Table
                    If (myTable.Columns(0).ToString() = "Name") Then
                        Dim myTableName As TreeNode = New TreeNode()
                        myTableName.Text = myTable.TableName.ToString()
                        myArrayList.Add(myTableName)
                    End If
                Next
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Views", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            successFlag = database.myDatabaseStoredProcs(myStoredProcData)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                Dim myTable As DataTable
                For Each myTable In myStoredProcData.Tables
                    'Me is the Main Table
                    If (myTable.Columns(0).ToString() = "Name") Then
                        Dim myTableName As TreeNode = New TreeNode()
                        myTableName.Text = myTable.TableName.ToString()
                        myArrayList.Add(myTableName)
                    End If
                Next
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount - 1) {}
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Stored Procs", myTables)
                myRootNode.Nodes.Add(myTableNameNode)
            End If
            treeView1.Nodes.Add(myRootNode)
        Else
            MessageBox.Show(Me, "Error in the connection Parameters, retry.")
        End If
        Return connectedFlag
    End Function

#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents contextMenu1 As ContextMenu
    Private WithEvents listView1 As ListView
    Private WithEvents treeView1 As TreeView

    Dim WithEvents DatabaseExplorer As System.Windows.Forms.Form

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.listView1 = New ListView()
        Me.contextMenu1 = New ContextMenu()
        Me.treeView1 = New TreeView()

        '@design Me.TrayHeight = 90
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        listView1.Location = New System.Drawing.Point(216, 8)
        listView1.Size = New System.Drawing.Size(352, 280)
        listView1.ForeColor = System.Drawing.SystemColors.WindowText
        listView1.TabIndex = 1
        listView1.Anchor = AnchorStyles.Left Or AnchorStyles.Bottom Or AnchorStyles.Top Or AnchorStyles.Right

        '@design contextMenu1.SetLocation(New System.Drawing.Point(7, 7))

        treeView1.Location = New System.Drawing.Point(0, 8)
        treeView1.Size = New System.Drawing.Size(216, 280)
        treeView1.TabIndex = 0
        treeView1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.Bottom
        Me.Text = "DatabaseExplorer"
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(568, 293)

        Me.Controls.Add(listView1)
        Me.Controls.Add(treeView1)
        AddHandler treeView1.MouseDown, AddressOf treeView1_MouseDown
    End Sub

#End Region
    'Handle the PopUp Menu for Stored Procs
    Protected Sub OnPopupParameters(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myTable As DataTable
        For Each myTable In myStoredProcData.Tables
            'MessageBox.Show(treeView1.SelectedNode.Text.ToString() + " " + myTable.TableName)
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                'messagebox.Show(myTable.Columns(0).ToString())
                If (myTable.Columns(0).ToString() = "Parameter_name") Then
                    listView1.Clear()
                    listView1.View = View.Details
                    'make columns
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    '//ADD the values to ListView
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues(myTable.Columns.Count) As String
                        Dim i As Integer = 0
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListViewItem = New ListViewItem(myValues)
                        listView1.Items.Add(myListItem)
                    Next
                End If
            End If
        Next
    End Sub
End Class
