Imports System.Drawing
Imports System.WinForms


Imports System.ComponentModel


Public Class DatabaseExplorer
    Inherits System.WinForms.Form
    Private userName As String
    Private password As String
    Private database As String
    Private SQLServer As String
    Private m_sConnectString As String
    Private myTableData As DataSet = New DataSet()
    Private myViewsData As DataSet = New DataSet()
    Private myStoredProcData As Data = New DataSet()
    Public Sub New(ByVal userName As String, ByVal password As String, ByVal database As String, ByVal SQLServer As String)
        MyBase.New()
        
        DatabaseExplorer = Me
        
        'This call is required by the Win Form Designer.
        InitializeComponent()
        Me.userName = userName
        Me.password = password
        Me.database = database
        Me.SQLServer = sqlServer
        
        'TODO: Add any initialization after the InitializeComponent() call
    End Sub
    
    'Form overrides dispose to clean up the component list.
    Public Overrides Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub
    Protected Sub DatabaseExplorer_OnClosing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        Me.WindowState = FormWindowState.Maximized
        e.Cancel = True
    End Sub
    Protected Sub treeView1_MouseDown(ByVal sender As Object, ByVal e As System.WinForms.MouseEventArgs)
        Select Case e.Button
            Case MouseButtons.Left
                
            Case MouseButtons.Right
                Dim mySelectedNode As TreeNode = Nothing
                mySelectedNode = treeView1.GetNodeAt(e.X, e.Y)
                treeView1.SelectedNode = mySelectedNode
                If (mySelectedNode <> Nothing) Then
                    Dim myParentNode As TreeNode = mySelectedNode.Parent
                    If (myParentNode <> Nothing) Then
                        If (myParentNode.Text.ToString() = "Tables") Then
                            ShowContextMenuForTable()
                            treeView1.ContextMenu = contextMenu1
                        ElseIf (myParentNode.Text.ToString() = "Stored Procs") Then
                            treeView1.ContextMenu = contextMenu1
                        ElseIf (myParentNode.Text.ToString() = "Views") Then
                            ShowContextMenuForTable()
                            treeView1.ContextMenu = contextMenu1
                        Else
                            treeView1.ContextMenu = null
                            listView1.Clear()
                        End If
                    Else
                        treeView1.ContextMenu = Nothing
                    End If
                    'Check the Parent if it is Tables then Show then this menus
                End If
            Case MouseButtons.Middle
                
            Case MouseButtons.None
                
            Case Else
        End Select
        
    End Sub
    Private Sub ShowContextMenuForTable()
        contextMenu1.MenuItems.Clear();
        contextMenu1.MenuItems.Add("Details", New System.EventHandler(this.OnPopupDetail))
        contextMenu1.MenuItems.Add("Identity", New System.EventHandler(this.OnPopupIdentity))
        contextMenu1.MenuItems.Add("FileGroups", New System.EventHandler(this.OnPopupFileGroups))
        contextMenu1.MenuItems.Add("Constraints", New System.EventHandler(this.OnPopupConstraints))
        contextMenu1.MenuItems.Add("References", New System.EventHandler(this.OnPopupReferences))
        contextMenu1.MenuItems.Add("Indexes", New System.EventHandler(this.OnPopupIndexes))
        contextMenu1.MenuItems.Add("RowGUIDcols", New System.EventHandler(this.OnPopupGUID))
    End Sub
    Protected Sub OnPopupDetail(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupIdentity(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupFileGroups(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupConstraints(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupReferences(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    Protected Sub OnPopupGUID(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    
    Protected Sub OnPopupIndexes(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    Private Sub ShowContextMenuForStoredProcedure()
        contextMenu1.MenuItems.Clear()
        contextMenu1.MenuItems.Add("Parameters", New System.EventHandler(Me.OnPopupParameters))
    End Sub
    'Handle the PopUp Menu for Stored Procs
    Protected Sub OnPopupParameters(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim myDataSet As DataSet = New DataSet()
        If (treeView1.SelectedNode.Parent.Text.ToString() = "Views") Then
            myDataSet = myViewsData
        Else
            myDataSet = myTableData
        End If
        Dim myTable As DataTable
        For Each myTable In myDataSet.Tables
            Dim iFound As Integer = -1
            iFound = myTable.TableName.IndexOf(treeView1.SelectedNode.Text.ToString(), 0)
            If (iFound >= 0) Then
                        if(myTable.Columns[0].ToString()="Column_name") Then
                    listView1.Clear()
                    listView1.View = View.Report
                    Dim myColumn As DataColumn
                    For Each myColumn In myTable.Columns
                        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                        myColumnHeader.Text = myColumn.ColumnName.ToString()
                        listView1.Columns.Add(myColumnHeader)
                    Next
                    Dim myValues As String() = New String(5)
                    Dim myRow As DataRow
                    For Each myRow In myTable.Rows
                        Dim myValues() As String = New String(myTable.Columns.Count)
							    Dim i as Integer=0;
                        For Each myColumn In myTable.Columns
                            myValues(i) = myRow(myColumn).ToString()
                            i += 1
                        Next
                        Dim myListItem As ListItem = New ListItem(myValues)
                                listView1.ListItems.Add(myListItem
                    Next
                End If
            End If
        Next
    End Sub
    Public ReadOnly Property ConnectionString() As String
        Get
            Return m_sConnectString
        End Get
    End Property
    Public Function buildTreeView() As Boolean
        Dim connectedFlag As Boolean = False
        Dim database As CAccessDatabase = New CAccessDatabase()
        Dim connString As String = "Provider=Microsoft.Jet.OLEDB.4.0" & _
                   "Data Source=" & Me.database & "" & _
                   "Jet OLEDB:System database=" & SQLServer & "User ID =" & userName & "Password =" & password & ""
        m_sConnectString = connString
        database.connectString = connString
        connectedFlag = database.Connect()
        If (connectedFlag) Then
            Dim myRootNode As TreeNode = New TreeNode(this.database)
            Dim successFlag As Boolean = False
            successFlag = database.myDatabaseTables(myTableData)
            If (successFlag) Then
                ArrayList(myArrayList = New ArrayList())
                Dim myTable As DataTable
                For Each myTable In myTableData.Tables
                    'This is the Main Table
                    Dim myTableName as TreeNode= New TreeNode())
                    myTableName.Text = myTable.TableName.ToString()
                    myArrayList.Add(myTableName)
                Next
                int(iArrayCount = myArrayList.Count)
                Dim myTables As TreeNode() = New TreeNode(iArrayCount)
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Tables", myTables)
                myRootNode.Nodes.Add(1, myTableNameNode)
            End If
            Dim myDataReader As ADODataReader
            
            successFlag = database.GetQueries(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables As TreeNode() = New TreeNode(iArrayCount)
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Queries", myTables)
                myRootNode.Nodes.Add(1, myTableNameNode)
            End If
            successFlag = database.GetForms(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables As TreeNode() = New TreeNode(iArrayCount)
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Forms", myTables)
                myRootNode.Nodes.Add(1, myTableNameNode)
            End If
            successFlag = database.GetReports(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables As TreeNode() = New TreeNode(iArrayCount)
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Reports", myTables)
                myRootNode.Nodes.Add(1, myTableNameNode)
            End If
            successFlag = database.GetMacros(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables() As TreeNode = New TreeNode(iArrayCount)
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Macros", myTables)
                myRootNode.Nodes.Add(1, myTableNameNode)
            End If
            successFlag = database.GetModules(myDataReader)
            If (successFlag) Then
                Dim myArrayList As ArrayList = New ArrayList()
                While (myDataReader.Read())
                    Dim myTableName As TreeNode = New TreeNode()
                    myTableName.Text = CType(myDataReader.GetValue(0), String)
                    myArrayList.Add(myTableName)
                End While
                myDataReader.Close()
                Dim iArrayCount As Integer = myArrayList.Count
                Dim myTables As TreeNode() = New TreeNode(iArrayCount)
                myArrayList.CopyTo(myTables)
                Dim myTableNameNode As TreeNode = New TreeNode("Modules", myTables)
                myRootNode.Nodes.Add(1, myTableNameNode)
            End If
            treeView1.Nodes.Add(1, myRootNode)
        Else
            MessageBox.Show(Me, "Error in the connection Parameters, retry.")
        End If
        Return connectedFlag
    End Function
    
#Region " Windows Form Designer generated code "
    
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents contextMenu1 As System.WinForms.ContextMenu
    Private WithEvents listView1 As System.WinForms.ListView
    Private WithEvents treeView1 As System.WinForms.TreeView
    
    Dim WithEvents DatabaseExplorer As System.WinForms.Form
    
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.listView1 = New System.WinForms.ListView()
        Me.contextMenu1 = New System.WinForms.ContextMenu()
        Me.treeView1 = New System.WinForms.TreeView()
        
        '@design Me.TrayHeight = 90
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        listView1.Location = New System.Drawing.Point(216, 8)
        listView1.Size = New System.Drawing.Size(352, 280)
        listView1.ForeColor = System.Drawing.SystemColors.WindowText
        listView1.TabIndex = 1
        listView1.Anchor = System.WinForms.AnchorStyles.All
        
        '@design contextMenu1.SetLocation(New System.Drawing.Point(7, 7))
        
        treeView1.Location = New System.Drawing.Point(0, 8)
        treeView1.Size = New System.Drawing.Size(216, 280)
        treeView1.TabIndex = 0
        treeView1.Anchor = System.WinForms.AnchorStyles.TopBottomLeft
        
        Me.Text = "DatabaseExplorer"
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(568, 293)
        
        Me.Controls.Add(listView1)
        Me.Controls.Add(treeView1)
    End Sub
    
#End Region
    
End Class
