Imports System.ComponentModel
Imports System.Drawing
Imports System.Diagnostics
Imports System.Windows.Forms



Public Class Form1
    Inherits System.Windows.Forms.Form
    
    'main reference to Process class of System.Diagnostics namespace
    Private ProcObj As Process = New Process()
    
    
    
    Public Sub New()
        MyBase.New()
        
        Form1 = Me
        
        'This call is required by the Win Form Designer.
        InitializeComponent()
        
        'TODO: Add any initialization after the InitializeComponent() call
        With lvwProcs.Columns
			.Add("Base Name", 110, HorizontalAlignment.Left)
			.Add("Modules", 70, HorizontalAlignment.Right)
			.Add("Full Path", 150, HorizontalAlignment.Left)
			.Add("PID", 40, HorizontalAlignment.Right)
			.Add("CPU Time", 70, HorizontalAlignment.Right)
			.Add("Mem Usage", 80, HorizontalAlignment.Right)
        End With
		
		With lvwThreads.Columns
			.Add("Thread ID", 85, HorizontalAlignment.Right)
			.Add("State", 100, HorizontalAlignment.Right)
			.Add("WaitReason", 258, HorizontalAlignment.Left)
			.Add("CPU Time", 70, HorizontalAlignment.Right)
		End With
		
		
		EnumProcs()
    End Sub
    
    'Form overrides dispose to clean up the component list.
    Public Overloads Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub

#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents lvwThreads As System.Windows.Forms.ListView
    Private WithEvents GroupBox1 As System.Windows.Forms.GroupBox


    Private WithEvents lvwProcs As System.Windows.Forms.ListView




    Dim WithEvents Form1 As System.Windows.Forms.Form

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.lvwThreads = New System.Windows.Forms.ListView()
        Me.lvwProcs = New System.Windows.Forms.ListView()
        Me.GroupBox1 = New System.Windows.Forms.GroupBox()

        '@design Me.TrayHeight = 90
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        '@design lvwThreads.Locked = True
        lvwThreads.Location = New System.Drawing.Point(9, 17)
        lvwThreads.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        lvwThreads.MultiSelect = False
        lvwThreads.Size = New System.Drawing.Size(518, 176)
        lvwThreads.FullRowSelect = True
        lvwThreads.View = System.Windows.Forms.View.Details
        lvwThreads.ForeColor = System.Drawing.SystemColors.WindowText
        lvwThreads.LabelWrap = False
        lvwThreads.TabIndex = 0

        '@design lvwProcs.Locked = True
        lvwProcs.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable
        lvwProcs.MultiSelect = False
        lvwProcs.Size = New System.Drawing.Size(540, 200)
        lvwProcs.FullRowSelect = True
        lvwProcs.View = System.Windows.Forms.View.Details
        lvwProcs.ForeColor = System.Drawing.SystemColors.WindowText
        lvwProcs.LabelWrap = False
        lvwProcs.TabIndex = 0

        GroupBox1.Location = New System.Drawing.Point(2, 202)
        GroupBox1.TabIndex = 1
        GroupBox1.TabStop = False
        GroupBox1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8!, System.Drawing.FontStyle.Bold)
        GroupBox1.Text = "Threads:"
        GroupBox1.Size = New System.Drawing.Size(539, 199)

        Me.Text = "Enumerate Processes"
        Me.MaximizeBox = False
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.ClientSize = New System.Drawing.Size(542, 400)

        GroupBox1.Controls.Add(lvwThreads)
        Me.Controls.Add(GroupBox1)
        Me.Controls.Add(lvwProcs)
    End Sub

#End Region


    Public Sub EnumProcs()
        Dim i As Integer
        Dim s As String
        Dim lstItem As ListViewItem
        Dim oProcs() As Process
        Dim TS As System.TimeSpan


        'retrieve all running processes
        oProcs = ProcObj.GetProcesses

        'insert all processes and their info into listview
        For i = 0 To UBound(oProcs)

            lstItem = Me.lvwProcs.Items.Add(oProcs(i).ProcessName)

            'catch module-less processes, like System Idle	
            Try
                lstItem.SubItems.Add(oProcs(i).Modules.Count.ToString)
                lstItem.SubItems.Add(oProcs(i).MainModule.FileName)
            Catch
                lstItem.SubItems.Add("0")
                lstItem.SubItems.Add("0")
            Finally

                lstItem.SubItems.Add(oProcs(i).Id.ToString)

                'get TimeSpan object
                TS = oProcs(i).TotalProcessorTime

                'properly format time
                lstItem.SubItems.Add(s.Format("{0:00}", TS.TotalHours) & ":" & _
                 s.Format("{0:00}", TS.Minutes) & ":" & _
                 s.Format("{0:00}", TS.Seconds))

                lstItem.SubItems.Add(CStr(oProcs(i).WorkingSet \ 1000) & "K")
            End Try
        Next
    End Sub



    Public Sub EnumThreads(ByVal ProcID As Integer)
        Dim oProc As Process
        Dim oThread As ProcessThread
        Dim TS As System.TimeSpan
        Dim s As String
        Dim lstItem As ListViewItem


        'clear the listview
        lvwThreads.Items.Clear()

        'get reference to process via process id		
        oProc = oProc.GetProcessById(ProcID)

        Try
            GroupBox1.Text = "Threads: " & oProc.Threads.Count.ToString
        Catch
            Exit Sub
        Finally
        End Try

        For Each oThread In oProc.Threads
            lstItem = lvwThreads.Items.Add(oThread.Id.ToString)

            Select Case oThread.ThreadState
                Case Diagnostics.ThreadState.Initialized
                    lstItem.SubItems.Add("Initialized")
                Case Diagnostics.ThreadState.Ready
                    lstItem.SubItems.Add("Ready")
                Case Diagnostics.ThreadState.Running
                    lstItem.SubItems.Add("Running")
                Case Diagnostics.ThreadState.Standby
                    lstItem.SubItems.Add("Standby")
                Case Diagnostics.ThreadState.Terminated
                    lstItem.SubItems.Add("Terminated")
                Case Diagnostics.ThreadState.Transition
                    lstItem.SubItems.Add("In Transition")
                Case Diagnostics.ThreadState.Unknown
                    lstItem.SubItems.Add("Unkwown")
                Case Diagnostics.ThreadState.Wait
                    lstItem.SubItems.Add("Waiting")
            End Select

            'if thread is in waiting state, print reason
            If oThread.ThreadState = Diagnostics.ThreadState.Wait Then
                lstItem.SubItems.Add(ListReason(oThread.WaitReason))
            Else
                lstItem.SubItems.Add("N/A")
            End If

            'get TimeSpan object
            TS = oThread.TotalProcessorTime

            'properly format time
            lstItem.SubItems.Add(s.Format("{0:00}", TS.TotalHours) & ":" & _
             s.Format("{0:00}", TS.Minutes) & ":" & _
             s.Format("{0:00}", TS.Seconds))
        Next
    End Sub


    Private Function ListReason(ByVal WaitingReason As Diagnostics.ThreadWaitReason) As String
        Select Case WaitingReason
            Case Diagnostics.ThreadWaitReason.EventPairHigh
                Return "Waiting For Event Pair High"
            Case Diagnostics.ThreadWaitReason.EventPairLow
                Return "Waiting For Event Pair Low"
            Case Diagnostics.ThreadWaitReason.ExecutionDelay
                Return "Execution Delay"
            Case Diagnostics.ThreadWaitReason.Executive
                Return "Waiting for Scheduler"
            Case Diagnostics.ThreadWaitReason.FreePage
                Return "Waiting For Free Virtual Mem. Page"
            Case Diagnostics.ThreadWaitReason.LpcReceive
                Return "Waiting For A Local Proc. Call To Arrive"
            Case Diagnostics.ThreadWaitReason.LpcReply
                Return "Waiting For A Reply To A Local Proc. Call"
            Case Diagnostics.ThreadWaitReason.PageIn
                Return "Waiting For Virtual Mem. Page To Arrive In Memory"
            Case Diagnostics.ThreadWaitReason.PageOut
                Return "Waiting For Virtual Mem. Page To Write To Disk"
            Case Diagnostics.ThreadWaitReason.Suspended
                Return "Execution Suspended"
            Case Diagnostics.ThreadWaitReason.SystemAllocation
                Return "Waiting For A System Allocation"
            Case Diagnostics.ThreadWaitReason.Unknown
                Return "Waiting For Unknown Reason"
            Case Diagnostics.ThreadWaitReason.UserRequest
                Return "Waiting For A User Request"
            Case Diagnostics.ThreadWaitReason.VirtualMemory
                Return "Waiting For Virtual Memory"
        End Select
    End Function



   
    Private Sub lvwProcs_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvwProcs.SelectedIndexChanged
        Try

            EnumThreads(CInt(lvwProcs.SelectedItems(0).SubItems(3).Text))

        Catch
        Finally
        End Try
    End Sub

End Class
