
Imports System.ComponentModel
Imports System.Drawing
Imports System.Windows.Forms

Public Class MainForm
    Inherits System.Windows.Forms.Form
    
    Public Sub New()
        MyBase.New()
        MainForm = Me
        MainForm.IsMdiContainer = True
        'ME call is required by the Win Form Designer.
        InitializeComponent()
        Dim miWindow As MenuItem = mainMenu1.MenuItems.Add("&Window")
        miWindow.MergeOrder = 10
        miWindow.MenuItems.Add("&Cascade", New EventHandler(AddressOf Me.WindowCascade_Clicked))
        miWindow.MenuItems.Add("Tile &Horizontal", New EventHandler(AddressOf Me.WindowTileH_Clicked))
        miWindow.MenuItems.Add("Tile &Vertical", New EventHandler(AddressOf Me.WindowTileV_Clicked))

        miWindow.MdiList = True
        MenuItem5.Enabled = False
        AddHandler Me.Closing, AddressOf MainForm_Closing
    End Sub


    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        Application.Exit()
    End Sub

    'Form overrides dispose to clean up the component list.
    Public Overloads Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub

#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private MenuItem6 As MenuItem
    Private MenuItem5 As MenuItem
    Private MenuItem4 As MenuItem
    Private MenuItem3 As MenuItem
    Private MenuItem2 As MenuItem
    Private MenuItem1 As MenuItem
    Private MainMenu1 As MainMenu
    Private menuItem8 As MenuItem
    Private menuItem7 As MenuItem
    Private WithEvents MainForm As System.Windows.Forms.Form
    Private frmQueryAnalyzer As QueryAnalyzer = Nothing
    Private ConnectionString As String = Nothing
    Private ConnectionStringAccess As String = Nothing

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.MainMenu1 = New MainMenu()
        Me.MenuItem5 = New MenuItem()
        Me.MenuItem4 = New MenuItem()
        Me.MenuItem1 = New MenuItem()
        Me.MenuItem6 = New MenuItem()
        Me.MenuItem3 = New MenuItem()
        Me.MenuItem2 = New MenuItem()

        '@design Me.TrayHeight = 90
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        '@design MainMenu1.SetLocation(New System.Drawing.Point(7, 7))
        Dim miWindow As MenuItem = MainMenu1.MenuItems.Add("&File")
        miWindow.MergeOrder = 10
        miWindow.MenuItems.Add("&Access Login", New EventHandler(AddressOf Me.menuItem2_Click))
        miWindow.MenuItems.Add("&SQL Login", New EventHandler(AddressOf Me.menuItem3_Click))
        miWindow.MenuItems.Add("E&xit", New EventHandler(AddressOf Me.menuItem4_Click))
        miWindow = MainMenu1.MenuItems.Add("&Tools", New EventHandler(AddressOf MenuItem5_Click))
        miWindow.Enabled = False
        miWindow.MenuItems.Add("&Query Analyzer", New EventHandler(AddressOf Me.menuItem6_Click))



        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.IsMdiContainer = True
        Me.Menu = MainMenu1
        Me.ClientSize = New System.Drawing.Size(520, 365)

    End Sub

#End Region

    Protected Sub MenuItem5_Click(ByVal sender As Object, ByVal e As System.EventArgs)

    End Sub
    Protected Sub menuItem8_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        LoginAccess()
    End Sub

    Protected Sub WindowCascade_Clicked(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub
    Protected Sub WindowTileH_Clicked(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub
    Protected Sub WindowTileV_Clicked(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub
    Protected Sub menuItem4_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Application.Exit()
    End Sub

    Protected Sub menuItem2_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        LoginAccess()
    End Sub
    Protected Sub menuItem3_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Login()
    End Sub
    Protected Sub menuItem6_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim fBoth As Boolean = False
        If ConnectionString <> Nothing And ConnectionStringAccess <> Nothing Then
            If (ConnectionString.Length > 0 And ConnectionStringAccess.Length > 0) Then
                fBoth = True
            End If
        End If
        If (Not fBoth) Then
            If (ConnectionString <> Nothing) Then
                frmQueryAnalyzer = New QueryAnalyzer(ConnectionString)
                frmQueryAnalyzer.myChoice = QueryAnalyzer.DatabaseChoice.SQLDatabase
                frmQueryAnalyzer.MdiParent = Me
                frmQueryAnalyzer.Show()
            Else
                frmQueryAnalyzer = New QueryAnalyzer(ConnectionStringAccess)
                frmQueryAnalyzer.myChoice = QueryAnalyzer.DatabaseChoice.AccessDatbase
                frmQueryAnalyzer.MdiParent = Me
                frmQueryAnalyzer.Show()
            End If
        Else
            frmQueryAnalyzer = New QueryAnalyzer()
            frmQueryAnalyzer.myChoice = QueryAnalyzer.DatabaseChoice.Both
            frmQueryAnalyzer.ConnectAccess = ConnectionStringAccess
            frmQueryAnalyzer.ConnectSQL = ConnectionString
            frmQueryAnalyzer.MdiParent = Me
            frmQueryAnalyzer.Show()
        End If
    End Sub
    Private Sub Login()
        Dim userName As String = Nothing
        Dim password As String = Nothing
        Dim database As String = Nothing
        Dim SQLServer As String = Nothing
        Dim SQLlogin As Login = New Login(userName, password, database, SQLServer, Me)
        If (userName.Length <> 0 And database.Length <> 0 And SQLServer.Length <> 0) Then
            MenuItem3.Enabled = False
            Dim frmExplore As frmDatabaseExplorer = New frmDatabaseExplorer(userName, password, database, SQLServer)
            If (frmExplore.buildTreeView()) Then
                MainMenu1.MenuItems.Item(1).Enabled = True  ' MenuItem5.Enabled = True
                'MainMenu1.MenuItems.Item(2).Enabled = False ' MenuItem3.Enabled = False
                MenuItem3.Enabled = False
                frmExplore.MdiParent = Me
                frmExplore.WindowState = FormWindowState.Maximized
                frmExplore.Show()
                ConnectionString = frmExplore.ConnectionString
            Else
                MenuItem3.Enabled = True
            End If
        Else
        End If
    End Sub
    Private Sub LoginAccess()
        Dim userName As String = Nothing
        Dim password As String = Nothing
        Dim database As String = Nothing
        Dim SQLServer As String = Nothing
        Dim access As LoginAccess = New LoginAccess(userName, password, database, SQLServer, Me)
        If (userName.Length <> 0 And database.Length <> 0 And SQLServer.Length <> 0) Then
            MenuItem2.Enabled = True
            Dim frmExplore As AccessExplorer = New AccessExplorer(userName, password, database, SQLServer)
            If (frmExplore.buildTreeView()) Then
                MainMenu1.MenuItems.Item(5).Enabled = True  ' MenuItem5.Enabled = True
                MainMenu1.MenuItems.Item(3).Enabled = False ' MenuItem3.Enabled = False
                frmExplore.MdiParent = Me
                frmExplore.WindowState = FormWindowState.Maximized
                frmExplore.Show()
                ConnectionStringAccess = frmExplore.ConnectionString
            Else
                MenuItem2.Enabled = True
            End If
        Else

        End If
    End Sub
    'Public Shared Sub Main()
    '    Application.Run(New MainForm())
    'End Sub
End Class
