Imports System.Drawing
Imports System.Windows.Forms


Imports System.ComponentModel


Public Class QueryAnalyzer
    Inherits System.Windows.Forms.Form
    Private m_sConnectionString As String
    Private m_sConnecionStringAccess As String
    Public Enum DatabaseChoice
        SQLDatabase = 0
        AccessDatbase = 1
        Both = 2
    End Enum
    Private m_myChoice As DatabaseChoice
    Public Property myChoice() As DatabaseChoice
        Get
            Return m_myChoice
        End Get
        Set
            m_myChoice = value
        End Set
    End Property
    
    Public WriteOnly Property ConnectSQL() As String
        Set
            m_sConnectionString = value
        End Set
    End Property
    Public WriteOnly Property ConnectAccess() As String
        Set
            m_sConnecionStringAccess = value
        End Set
    End Property
    Public Sub New(ByRef ConnectionString As String)
        MyBase.New()
        InitializeComponent()
        m_sConnectionString = ConnectionString
        cmbDatabase.Enabled = False
        AddHandler richTextBox1.KeyDown, AddressOf Me.richTextBox1_OnKeyDown
    End Sub

    Public Sub New()
        MyBase.New()

        QueryAnalyzer = Me

        'ME call is required by the Win Form Designer.
        InitializeComponent()
        cmbDatabase.Items.Add("Access")
        cmbDatabase.Items.Add("SQL Server")
        'TODO: Add any initialization after the InitializeComponent() call
    End Sub

    'Form overrides dispose to clean up the component list.
    Public Overloads Sub Dispose()
        MyBase.Dispose()
        components.Dispose()
    End Sub

#Region " Windows Form Designer generated code "

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container
    Private WithEvents ListView1 As ListView
    Private WithEvents TabPage1 As TabPage
    Private WithEvents TabControl1 As TabControl


    Private WithEvents label1 As Label



    Private WithEvents button1 As Button
    Private WithEvents cmbDatabase As ComboBox
    Private WithEvents richTextBox1 As RichTextBox

    Dim WithEvents QueryAnalyzer As System.Windows.Forms.Form

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.TabPage1 = New TabPage()
        Me.cmbDatabase = New ComboBox()
        Me.button1 = New Button()
        Me.richTextBox1 = New RichTextBox()
        Me.TabControl1 = New TabControl()
        Me.ListView1 = New ListView()
        Me.label1 = New Label()

        '@design Me.TrayHeight = 0
        '@design Me.TrayLargeIcon = False
        '@design Me.TrayAutoArrange = True
        TabPage1.Text = "Result1"
        TabPage1.Size = New System.Drawing.Size(312, 158)
        TabPage1.TabIndex = 0

        cmbDatabase.Location = New System.Drawing.Point(72, 0)
        cmbDatabase.Size = New System.Drawing.Size(121, 21)
        cmbDatabase.DropDownStyle = ComboBoxStyle.DropDownList
        cmbDatabase.TabIndex = 1

        button1.Location = New System.Drawing.Point(236, 0)
        button1.Size = New System.Drawing.Size(72, 24)
        button1.TabIndex = 2
        button1.Anchor = AnchorStyles.Top Or AnchorStyles.Right
        button1.Text = "Execute!"

        richTextBox1.Size = New System.Drawing.Size(328, 112)
        richTextBox1.TabIndex = 0
        richTextBox1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.Right
        richTextBox1.Location = New System.Drawing.Point(0, 24)

        TabControl1.Location = New System.Drawing.Point(0, 144)
        TabControl1.Size = New System.Drawing.Size(320, 184)
        TabControl1.SelectedIndex = 0
        TabControl1.Alignment = TabAlignment.Bottom
        TabControl1.TabIndex = 5
        TabControl1.Anchor = AnchorStyles.Bottom Or AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.Right

        ListView1.Size = New System.Drawing.Size(320, 152)
        ListView1.ForeColor = System.Drawing.SystemColors.WindowText
        ListView1.TabIndex = 0
        ListView1.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Bottom Or AnchorStyles.Top

        label1.Location = New System.Drawing.Point(16, 8)
        label1.Text = "Database"
        label1.Size = New System.Drawing.Size(56, 16)
        label1.TabIndex = 4

        Me.Text = "QueryAnalyzer"
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(320, 333)

        TabControl1.Controls.Add(TabPage1)
        Me.Controls.Add(TabControl1)
        Me.Controls.Add(label1)
        Me.Controls.Add(button1)
        Me.Controls.Add(cmbDatabase)
        Me.Controls.Add(richTextBox1)
        TabPage1.Controls.Add(ListView1)
        AddHandler button1.Click, AddressOf button1_Click
    End Sub

#End Region
    Protected Sub button1_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim connstring As String
        If (m_myChoice = DatabaseChoice.Both) Then
            If (cmbDatabase.Text = "Access") Then
                connstring = m_sConnecionStringAccess
            Else
                connstring = m_sConnectionString
            End If
        Else
            If (m_myChoice = DatabaseChoice.AccessDatbase) Then
                connstring = m_sConnecionStringAccess
            Else
                connstring = m_sConnectionString
            End If
        End If
        Execute(connstring)
    End Sub
    Protected Sub richTextBox1_OnKeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        If e.Control Then
            If e.KeyCode = Keys.E Then
                Dim connstring As String
                If (m_myChoice = DatabaseChoice.Both) Then
                    If (cmbDatabase.Text = "Access") Then
                        connstring = m_sConnecionStringAccess
                    Else
                        connstring = m_sConnectionString
                    End If
                Else
                    If (m_myChoice = DatabaseChoice.AccessDatbase) Then
                        connstring = m_sConnecionStringAccess
                    Else
                        connstring = m_sConnectionString
                    End If
                End If
                Execute(connstring)
                e.Handled = True
            End If
        End If
    End Sub
    Private Sub Execute(ByRef connString As String)
        Dim database As CDatabase = New CDatabase(connString)
        Dim mySuccessflsg As Boolean = database.Connect()
        If (mySuccessflsg) Then
            Dim myDataSet As DataSet = Nothing
            Dim SQL As String = richTextBox1.Text.ToString()
            Dim mySQLError As String
            Dim myQueryflag As Boolean = database.ExecuteSQL(SQL, myDataSet, mySQLError)
            If (myQueryflag) Then
                DisplayData(myDataSet)
            Else
                DisplayData(mySQLError)
            End If
        End If
    End Sub
    Private Overloads Sub DisplayData(ByRef myDataSet As DataSet)
        Try
            Dim itableCount As Integer = myDataSet.Tables.Count
            Dim iTabCount As Integer = TabControl1.TabCount
            Dim i As Integer
            For i = 1 To iTabCount - 1
                TabControl1.Controls.Remove(TabControl1.Controls.Item(i))
            Next
            Dim myListView() As ListView = New ListView(itableCount) {}
            Dim myTabPages() As TabPage = New TabPage(itableCount) {}
            myListView(0) = ListView1
            i = 0
            For i = 1 To itableCount - 1
                myListView(i) = New ListView()
                myListView(i).Size = ListView1.Size
                myListView(i).ForeColor = System.Drawing.SystemColors.WindowText
                myListView(i).TabIndex = i
                myListView(i).Anchor = AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top
                myTabPages(i) = New TabPage("Result" & (i + 1))
                myTabPages(i).Size = TabPage1.Size
                myTabPages(i).TabIndex = i
                myTabPages(i).Anchor = AnchorStyles.Bottom.Left.Right.Top
                TabControl1.Controls.Add(myTabPages(i))
                myTabPages(i).Controls.Add(myListView(i))
            Next
            Dim iListViewinArray As Integer = 0
            Dim myTable As DataTable
            For Each myTable In myDataSet.Tables
                myListView(iListViewinArray).Clear()
                myListView(iListViewinArray).View = View.Details
                Dim myColumn As DataColumn
                For Each myColumn In myTable.Columns
                    Dim myColumnHeader As ColumnHeader = New ColumnHeader()
                    myColumnHeader.Text = myColumn.ColumnName.ToString()
                    myListView(iListViewinArray).Columns.Add(myColumnHeader)
                Next
                Dim myRow As DataRow
                For Each myRow In myTable.Rows
                    Dim myValues() As String = New String(myTable.Columns.Count) {}
                    i = 0
                    For Each myColumn In myTable.Columns
                        myValues(i) = myRow(myColumn).ToString()
                        i += 1
                    Next
                    Dim myListItem As ListViewItem = New ListViewItem(myValues)
                    myListView(iListViewinArray).Items.Add(myListItem)
                Next
                iListViewinArray += 1
            Next
        Catch e As Exception
            MessageBox.Show(Me, "Error in Displaying Result", "Display Error", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Overloads Sub DisplayData(ByRef mySQLErro As String)
        Dim iTabCount As Integer = TabControl1.TabCount
        Dim i As Integer
        For i = 1 To iTabCount - 1
            TabControl1.Controls.Remove(TabControl1.Controls.Item(i))
        Next
        ListView1.Clear()
        ListView1.View = View.Details
        Dim myColumnHeader As ColumnHeader = New ColumnHeader()
        myColumnHeader.Text = "SQL Query returns Error"
        ListView1.Columns.Add(myColumnHeader)
        ListView1.Items.Add(mySQLErro)
    End Sub
End Class
